datablock TSShapeConstructor(MonsterDts)
{
	baseShape  = "./monster.dts";
	sequence0  = "./root.dsq root";
	sequence1  = "./lf_open.dsq ldopen";
	sequence2  = "./lf_close.dsq ldclose";
	sequence3  = "./rf_open.dsq rdopen";
	sequence4  = "./rf_close.dsq rdclose";
	sequence5  = "./bonnet_open.dsq bonnetOpen";
	sequence6  = "./bonnet_close.dsq bonnetClose";
	sequence7  = "./gate_open.dsq gateOpen";
	sequence8  = "./gate_close.dsq gateClose";
}; 

datablock ParticleData(MonsterTireParticle)
{
   dragCoefficient      = 0;
   windCoefficient     = 0;
   gravityCoefficient   = 2.5;
   inheritedVelFactor   = 0.0;
   constantAcceleration = 0.0;
   spinSpeed = "0";
   spinRandomMin = 0;
   spinRandomMax = 0;
   useInvAlpha = "1";
   lifetimeMS           = 800;
   lifetimeVarianceMS   = 300;
   textureName          = "base/data/particles/chunk";
   colors[0] = "0.000000 0.000000 0.000000 1.000000";
   colors[1] = "0.000000 0.000000 0.000000 0.000000";
   colors[2] = "1.000000 1.000000 1.000000 1.000000";
   colors[3] = "1.000000 1.000000 1.000000 1.000000";
   sizes[0] = "0.247207";
   sizes[1] = "0.8";
   sizes[2] = "1.4";
   sizes[3] = "1.4";
   times[0] = "0";
   times[1] = "1";
   times[2] = "2";
   times[3] = "2";
};

datablock ParticleEmitterData(MonsterTireEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 3;
   ejectionOffset   = 0.09;
   thetaMin         = 10;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "MonsterTireParticle";
};

datablock WheeledVehicleData(MonsterVehicle)
{
	category = "Vehicles";
	displayName = " ";
	shapeFile = "./Monster.dts"; 
	emap = true;
	minMountDist = 3;
   
   numMountPoints = 5;
   mountThread[0] = "sit";
   mountThread[1] = "sit";
   mountThread[2] = "root";
   mountThread[3] = "root";
   mountThread[4] = "root";


	maxDamage = 400.00;
	destroyedLevel = 400.00;
	energyPerDamagePoint = 160;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	massCenter = "0 0 -0.6";
   //massBox = "2 5 1";

	maxSteeringAngle = 0.75;  // Maximum steering angle, should match animation 0.9785
	integration = 4;           // Force integration time: TickSec/Rate
	tireEmitter = MonsterTireEmitter; // All the tires use the same dust emitter, except these, 
					  // because they're huge

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 10;         // Far distance from vehicle
	cameraOffset = 7.5;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.4;
   collisionTol = 0.1;        // Collision distance tolerance
   contactTol = 0.1;

	useEyePoint = false;	

	defaultTire	 = MonsterTire;
	defaultSpring = MonsterSpring;
	flatTire	    = jeepFlatTire;
	flatSpring	 = jeepFlatSpring;

   numWheels = 4;

	// Rigid Body
	mass = 800;
	density = 5.0;
	drag = 1.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;        // Impacts over this invoke the script callback
	softImpactSpeed = 10;       // Play SoftImpact Sound
	hardImpactSpeed = 15;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 24000; //4000;       // Engine power
	engineBrake = 14000;         // Braking when throttle is 0
	brakeTorque = 14000;        // When brakes are applied
	maxWheelSpeed = 22;        // Engine scale by current speed / max speed

	rollForce		= 1000;
	yawForce		= 600;
	pitchForce		= 2000;
	rotationalDrag		= 2;
	
	// Advanced Steering
   steeringAutoReturn = true;
   steeringAutoReturnRate = 0.9;
   steeringAutoReturnMaxSpeed = 10;
   steeringUseStrafeSteering = true;
   steeringStrafeSteeringRate = 0.1;
	
	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";
	
	// Sounds
	//   jetSound = ScoutThrustSound;
	//engineSound = idleSound;
	//squealSound = skidSound;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	//wheelImpactSound = slowImpactSound;

	//   explosion = VehicleExplosion;
	justcollided = 0;

   uiName = "Monster Truck";
	rideable = true;
		lookUpLimit = 0.65;
		lookDownLimit = 0.45;

	paintable = true;
   
   damageEmitter[0] = vehicleBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;

   damageEmitter[1] = vehicleBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;

   numDmgEmitterAreas = 1;

   initialExplosionProjectile = MonsterExplosionProjectile;
   initialExplosionOffset = 0;         //offset only uses a z value for now

   burnTime = 4000;

   finalExplosionProjectile = MonsterFinalExplosionProjectile;
   finalExplosionOffset = 0.5;          //offset only uses a z value for now

   minRunOverSpeed    = 0.8;   //how fast you need to be going to run someone over (do damage)
   runOverDamageScale = 15;   //when you run over someone, speed * runoverdamagescale = damage amt
   runOverPushScale   = 1; //how hard a person you're running over gets pushed

   isInteractive = true;
   iNumZones = 4;

   iZone[0] = "-2.2 -0.2 0.5 -1.5 1.5 3.3";
   iZoneScript[0] = "onLeftDoor";

   iZone[1] = "1.5 -0.2 0.5 2.2 1.5 3.3";
   iZoneScript[1] = "onRightDoor";

   iZone[2] = "-1.9 1.6 1.8 1.9 3.3 2.8";
   iZoneScript[2] = "onBonnet";

   iZone[3] = "-1.3 -3.7 1.2 1.3 -2.5 2.2";
   iZoneScript[3] = "onGate";
};

function MonsterVehicle::onLeftDoor(%this, %obj, %client, %offset, %position, %vector)
{
        %time = getSimTime();
        if((%time - %obj.leftDoorTime) > 1300)
        {
                %obj.leftDoorTime = %time;
                %obj.leftDoor = !%obj.leftDoor;
                %obj.playThread(0, %obj.leftDoor ? ldOpen : ldClose);
        }

        return 1;
}

function MonsterVehicle::onRightDoor(%this, %obj, %client, %offset, %position, %vector)
{
        %time = getSimTime();
        if((%time - %obj.rightDoorTime) > 1300)
        {
                %obj.rightDoorTime = %time;
                %obj.rightDoor = !%obj.rightDoor;
                %obj.playThread(1, %obj.rightDoor ? rdOpen : rdClose);
        }

        return 1;
}

function MonsterVehicle::onbonnet(%this, %obj, %client, %offset, %position, %vector)
{
        %time = getSimTime();
        if((%time - %obj.bonnetTime) > 1300)
        {
                %obj.bonnetTime = %time;
                %obj.bonnet = !%obj.bonnet;
                %obj.playThread(2, %obj.bonnet ? bonnetOpen : bonnetClose);
        }

        return 1;
}

function MonsterVehicle::ongate(%this, %obj, %client, %offset, %position, %vector)
{
        %time = getSimTime();
        if((%time - %obj.gateTime) > 1300)
        {
                %obj.gateTime = %time;
                %obj.gate = !%obj.gate;
                %obj.playThread(3, %obj.gate ? gateOpen : gateClose);
        }

        return 1;
}


function MonsterVehicle::onAdd(%db,%this)	
{

%chance1 = getRandom(0,3);

switch(%chance1)			
{
case 0:			
 //do nothing

case 1:							
%this.hideNode(spoiler);

case 2:							
%this.hideNode(cage_lights);
%this.hideNode(spoiler);

case 3:							
%this.hideNode(cage_lights);
}

   // 4 wheel steering
   %this.setWheelSteering(0,1);
   %this.setWheelSteering(1,1);
   %this.setWheelSteering(2,-0.8);
   %this.setWheelSteering(3,-0.8);

   // 4 wheel drive
   %this.setWheelPowered(0,true);
   %this.setWheelPowered(1,true);
   %this.setWheelPowered(2,true);
   %this.setWheelPowered(3,true);

   %this.setWheelTire(0, MonsterTire);
   %this.setWheelTire(1, MonsterTire);
   %this.setWheelTire(2, MonsterTire);
   %this.setWheelTire(3, MonsterTire);

   %this.setWheelSpring(0, MonsterSpring);
   %this.setWheelSpring(1, MonsterSpring);
   %this.setWheelSpring(2, MonsterSpring);
   %this.setWheelSpring(3, MonsterSpring);

MonsterSmokeCheck(%this);
  
 parent::onadd(%db,%this);

}